ctdb-scripts: Dump stack traces of smbd processes after shutdown
[samba.git] / ctdb / config / events.d / 50.samba
index 814fb9aec45df487589e0af149ccdd03c262d8a7..4ed892cdc5905e3efaa45e9441109a59e781c2f7 100755 (executable)
@@ -1,11 +1,10 @@
 #!/bin/sh
 # ctdb event script for Samba
 
-PATH=/bin:/usr/bin:$PATH
+[ -n "$CTDB_BASE" ] || \
+    CTDB_BASE=$(d=$(dirname "$0") ; cd -P "$d" ; dirname "$PWD")
 
-. $CTDB_BASE/functions
-loadconfig ctdb
-loadconfig samba
+. "${CTDB_BASE}/functions"
 
 detect_init_style
 
@@ -13,249 +12,179 @@ case $CTDB_INIT_STYLE in
        suse)
                CTDB_SERVICE_SMB=${CTDB_SERVICE_SMB:-smb}
                CTDB_SERVICE_NMB=${CTDB_SERVICE_NMB:-nmb}
-               CTDB_SERVICE_WINBIND=${CTDB_SERVICE_WINBIND:-winbind}
                ;;
        debian)
                CTDB_SERVICE_SMB=${CTDB_SERVICE_SMB:-samba}
                CTDB_SERVICE_NMB=${CTDB_SERVICE_NMB:-""}
-               CTDB_SERVICE_WINBIND=${CTDB_SERVICE_WINBIND:-winbind}
-               ;;
-       redhat)
-               CTDB_SERVICE_SMB=${CTDB_SERVICE_SMB:-smb}
-               CTDB_SERVICE_NMB=${CTDB_SERVICE_NMB:-""}
-               CTDB_SERVICE_WINBIND=${CTDB_SERVICE_WINBIND:-winbind}
                ;;
        *)
-               # should not happen, but for now use redhat style as default:
+               # Use redhat style as default:
                CTDB_SERVICE_SMB=${CTDB_SERVICE_SMB:-smb}
                CTDB_SERVICE_NMB=${CTDB_SERVICE_NMB:-""}
-               CTDB_SERVICE_WINBIND=${CTDB_SERVICE_WINBIND:-winbind}
                ;;
 esac
 
-cmd="$1"
-shift
+# service_name is used by various functions
+# shellcheck disable=SC2034
+service_name="samba"
+
+loadconfig
+
+service_state_dir=$(ctdb_setup_service_state_dir) || exit $?
+
+service_start ()
+{
+    # make sure samba is not already started
+    service "$CTDB_SERVICE_SMB" stop > /dev/null 2>&1
+    if [ -n "$CTDB_SERVICE_NMB" ] ; then
+       service "$CTDB_SERVICE_NMB" stop > /dev/null 2>&1
+    fi
+    killall -0 -q smbd && {
+       sleep 1
+       # make absolutely sure samba is dead
+       killall -q -9 smbd
+    }
+    killall -0 -q nmbd && {
+       sleep 1
+       # make absolutely sure samba is dead
+       killall -q -9 nmbd
+    }
 
-[ "$CTDB_MANAGES_SAMBA" = "yes" ] || [ "$CTDB_MANAGES_WINBIND" = "yes" ] || exit 0
+    # start Samba service. Start it reniced, as under very heavy load
+    # the number of smbd processes will mean that it leaves few cycles
+    # for anything else
+    net serverid wipe
 
+    if [ -n "$CTDB_SERVICE_NMB" ] ; then
+       nice_service "$CTDB_SERVICE_NMB" start || die "Failed to start nmbd"
+    fi
 
-# set default samba cleanup period - in minutes
-[ -z "$SAMBA_CLEANUP_PERIOD" ] && {
-    SAMBA_CLEANUP_PERIOD=10
+    nice_service "$CTDB_SERVICE_SMB" start || die "Failed to start samba"
 }
 
-# we keep a cached copy of smb.conf here
-smbconf_cache="$CTDB_BASE/state/samba/smb.conf.cache"
+service_stop ()
+{
+    service "$CTDB_SERVICE_SMB" stop
+    program_stack_traces "smbd" 5
+    if [ -n "$CTDB_SERVICE_NMB" ] ; then
+       service "$CTDB_SERVICE_NMB" stop
+    fi
+}
 
+######################################################################
+# Show the testparm output using a cached smb.conf to avoid delays due
+# to registry access.
+
+smbconf_cache="$service_state_dir/smb.conf.cache"
+
+testparm_foreground_update ()
+{
+    _timeout="$1"
+
+    # No need to remove these temporary files, since there are only 2
+    # of them.
+    _out="${smbconf_cache}.out"
+    _err="${smbconf_cache}.err"
+
+    timeout "$_timeout" testparm -v -s >"$_out" 2>"$_err"
+    case $? in
+       0) : ;;
+       124)
+           if [ -f "$smbconf_cache" ] ; then
+               echo "WARNING: smb.conf cache update timed out - using old cache file"
+               return 1
+           else
+               echo "ERROR: smb.conf cache create failed - testparm command timed out"
+               exit 1
+           fi
+           ;;
+       *)
+           if [ -f "$smbconf_cache" ] ; then
+               echo "WARNING: smb.conf cache update failed - using old cache file"
+               cat "$_err"
+               return 1
+           else
+               echo "ERROR: smb.conf cache create failed - testparm failed with:"
+               cat "$_err"
+               exit 1
+           fi
+    esac
+
+    # Only using $$ here to avoid a collision.  This is written into
+    # CTDB's own state directory so there is no real need for a secure
+    # temporary file.
+    _tmpfile="${smbconf_cache}.$$"
+    # Patterns to exclude...
+    _pat='^[[:space:]]+(registry[[:space:]]+shares|include|copy|winbind[[:space:]]+separator)[[:space:]]+='
+    grep -Ev "$_pat" <"$_out" >"$_tmpfile"
+    mv "$_tmpfile" "$smbconf_cache" # atomic
 
-#############################################
-# update the smb.conf cache in the foreground
-testparm_foreground_update() {
-    mkdir -p "$CTDB_BASE/state/samba" || exit 1
-    testparm -s 2> /dev/null | egrep -v 'registry.shares.=|include.=' > "$smbconf_cache"
+    return 0
 }
 
-#############################################
-# update the smb.conf cache in the background
-testparm_background_update() {
-    # if the cache doesn't exist, then update in the foreground
-    [ -f $smbconf_cache ] || {
-       testparm_foreground_update
-    }
-    # otherwise do a background update
-    (
-       tmpfile="${smbconf_cache}.$$"
-       testparm -s > $tmpfile 2> /dev/null &
-       # remember the pid of the teamparm process
-       pid="$!"
-       # give it 10 seconds to run
-       timeleft=10
-       while [ $timeleft -gt 0 ]; do
-           timeleft=$(($timeleft - 1))
-           # see if the process still exists
-           /bin/kill -0 $pid > /dev/null 2>&1 || {
-               # it doesn't exist, grab its exit status
-               wait $pid
-               [ $? = 0 ] || {
-                   echo "50.samba: smb.conf background update exited with status $?"
-                   rm -f "${tmpfile}"
-                   exit 1
-               }               
-               # put the new smb.conf contents in the cache (atomic rename)
-               # make sure we remove references to the registry while doing 
-               # this to ensure that running testparm on the cache does
-               # not use the registry
-               egrep -v 'registry.shares.=|include.=' < "$tmpfile" > "${tmpfile}.2"
-               rm -f "$tmpfile"
-               mv -f "${tmpfile}.2" "$smbconf_cache" || {
-                   echo "50.samba: failed to update background cache"
-                   rm -f "${tmpfile}.2"
-                   exit 1
-               }
-               exit 0
-           }
-           # keep waiting for testparm to finish
-           sleep 1
-       done
-       # it took more than 10 seconds - kill it off
-       rm -f "${tmpfile}"
-       /bin/kill -9 "$pid" > /dev/null 2>&1
-       echo "50.samba: timed out updating smbconf cache in background"
-       exit 1
-    ) &
+testparm_background_update ()
+{
+    _timeout="$1"
+
+    testparm_foreground_update "$_timeout" >/dev/null 2>&1 </dev/null &
 }
 
-##################################################
-# show the testparm output using a cached smb.conf 
-# to avoid registry access
-testparm_cat() {
-    [ -f $smbconf_cache ] || {
-       testparm_foreground_update
-    }
+testparm_cat ()
+{
     testparm -s "$smbconf_cache" "$@" 2>/dev/null
 }
 
-# function to see if ctdb manages winbind
-check_ctdb_manages_winbind() {
-  [ -z "$CTDB_MANAGES_WINBIND" ] && {
-    secmode=`testparm_cat --parameter-name=security`
-    case $secmode in
-       ADS|DOMAIN)
-           CTDB_MANAGES_WINBIND="yes";
-           ;;
-       *)
-           CTDB_MANAGES_WINBIND="no";
-           ;;
-    esac
-  }
+list_samba_shares ()
+{
+    testparm_cat |
+    sed -n -e 's@^[[:space:]]*path[[:space:]]*=[[:space:]]@@p' |
+    sed -e 's/"//g'
 }
 
-###########################
-# periodic cleanup function
-periodic_cleanup() {
-    # running smbstatus scrubs any dead entries from the connections
-    # and sessionid database
-    # echo "Running periodic cleanup of samba databases"
-    smbstatus -np > /dev/null 2>&1 &
+list_samba_ports ()
+{
+    testparm_cat --parameter-name="smb ports" |
+    sed -e 's@,@ @g'
 }
 
-case $cmd in 
-     startup)
-       # create the state directory for samba
-       /bin/mkdir -p $CTDB_BASE/state/samba
-
-       # make sure samba is not already started
-       [ "$CTDB_MANAGES_SAMBA" = "yes" ] && {
-               service "$CTDB_SERVICE_SMB" stop > /dev/null 2>&1
-               service "$CTDB_SERVICE_NMB" stop > /dev/null 2>&1
-               killall -0 -q smbd && {
-                   sleep 1
-                   # make absolutely sure samba is dead
-                   killall -q -9 smbd
-               }
-
-               killall -0 -q nmbd && {
-                   sleep 1
-                   # make absolutely sure samba is dead
-                   killall -q -9 nmbd
-               }
-       }
-
-       # restart the winbind service
-       check_ctdb_manages_winbind
-       [ "$CTDB_MANAGES_WINBIND" = "yes" ] && {
-               service "$CTDB_SERVICE_WINBIND" stop > /dev/null 2>&1
-               killall -0 -q winbindd && {
-                   sleep 1
-                   # make absolutely sure winbindd is dead
-                   killall -q -9 winbindd
-               }
-               service "$CTDB_SERVICE_WINBIND" start
-       }
-
-       # start Samba service. Start it reniced, as under very heavy load 
-       # the number of smbd processes will mean that it leaves few cycles for
-       # anything else
-       [ "$CTDB_MANAGES_SAMBA" = "yes" ] && {
-               nice_service "$CTDB_SERVICE_NMB" start
-               nice_service "$CTDB_SERVICE_SMB" start
-       }
-       ;;
-       
-     takeip)
-       # nothing special for Samba
-       ;;
+###########################
 
-     releaseip)
-       # nothing special for Samba
-       ;;
+ctdb_start_stop_service
 
-     recovered)
-       # nothing special for Samba
-       exit 0
-       ;;
+is_ctdb_managed_service || exit 0
 
-     shutdown)
-       # shutdown Samba when ctdb goes down
-       [ "$CTDB_MANAGES_SAMBA" = "yes" ] && {
-               service "$CTDB_SERVICE_SMB" stop
-               service "$CTDB_SERVICE_NMB" stop
-       }
-
-       # stop the winbind service
-       check_ctdb_manages_winbind
-       [ "$CTDB_MANAGES_WINBIND" = "yes" ] && {
-               service "$CTDB_SERVICE_WINBIND" stop
-       }
+###########################
+
+case "$1" in
+startup)
+       ctdb_service_start
        ;;
 
-     monitor)
-       # Create a dummy file to track when we need to do periodic cleanup
-       # of samba databases
-       [ -f $CTDB_BASE/state/samba/periodic_cleanup ] || {
-               touch $CTDB_BASE/state/samba/periodic_cleanup
-       }
-       [ `/usr/bin/find $CTDB_BASE/state/samba/periodic_cleanup -mmin +$SAMBA_CLEANUP_PERIOD | wc -l` -eq 1 ] && {
-               # Cleanup the databases
-               periodic_cleanup
-               touch $CTDB_BASE/state/samba/periodic_cleanup
-       }
-
-       [ "$CTDB_MANAGES_SAMBA" = "yes" ] && {
-               [ "$CTDB_SAMBA_SKIP_SHARE_CHECK" = "yes" ] || {
-                       testparm_background_update
-
-                       testparm_cat | egrep '^WARNING|^ERROR|^Unknown' && {
-                           testparm_foreground_update
-                           testparm_cat | egrep '^WARNING|^ERROR|^Unknown' && {
-                               echo "ERROR: testparm shows smb.conf is not clean"
-                               exit 1
-                           }
-                       }
-
-                       smb_dirs=`testparm_cat | egrep '^[[:space:]]*path = ' | cut -d= -f2`
-                       ctdb_check_directories_probe "Samba" $smb_dirs || {
-                           testparm_foreground_update
-                           smb_dirs=`testparm_cat | egrep '^[[:space:]]*path = ' | cut -d= -f2`
-                           ctdb_check_directories "Samba" $smb_dirs
-                       }
-               }
-
-               smb_ports="$CTDB_SAMBA_CHECK_PORTS"
-               [ -z "$smb_ports" ] && {
-                       smb_ports=`testparm_cat --parameter-name="smb ports"`
-               }
-               ctdb_check_tcp_ports "Samba" $smb_ports
-       }
-
-       # check winbind is OK
-       check_ctdb_manages_winbind
-       [ "$CTDB_MANAGES_WINBIND" = "yes" ] && {
-               ctdb_check_command "winbind" "wbinfo -p"
-       }
+shutdown)
+       ctdb_service_stop
        ;;
 
+monitor)
+       testparm_foreground_update 10
+       ret=$?
+
+       smb_ports="$CTDB_SAMBA_CHECK_PORTS"
+       if [ -z "$smb_ports" ] ; then
+           smb_ports=$(list_samba_ports)
+           [ -n "$smb_ports" ] || die "Failed to set smb ports"
+       fi
+       # Intentionally unquoted multi-word value here
+       # shellcheck disable=SC2086
+       ctdb_check_tcp_ports $smb_ports || exit $?
+
+       if [ "$CTDB_SAMBA_SKIP_SHARE_CHECK" != "yes" ] ; then
+           list_samba_shares | ctdb_check_directories || exit $?
+       fi
+
+       if [ $ret -ne 0 ] ; then
+           testparm_background_update 10
+       fi
+       ;;
 esac
 
-# ignore unknown commands
 exit 0